Bug 1476584 - (deepin-session-ui) Review Request: deepin-session-ui - Deepin desktop-environment Session UI module
Review Request: deepin-session-ui - Deepin desktop-environment Session UI module
Status: POST
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Robert-André Mauchin
Fedora Extras Quality Assurance
:
Depends On:
Blocks: DeepinDEPackageReview
  Show dependency treegraph
 
Reported: 2017-07-30 09:07 EDT by sensor.wen
Modified: 2017-12-31 20:45 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
zebob.m: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description sensor.wen 2017-07-30 09:07:24 EDT
SPEC: https://raw.githubusercontent.com/FZUG/repo/master/rpms/deepin_project/deepin-session-ui.spec

Description: Deepin desktop-environment Session UI module

Fedora Account System Username: mosquito
Comment 2 Robert-André Mauchin 2017-08-06 11:24:41 EDT
Hello,

 - The package name should follow upstream convention, dde-session-ui
 - You must validate .desktop file with desktop-file-validate in %check. See https://fedoraproject.org/wiki/Packaging:Guidelines#desktop-file-install_usage
 - As I said in other review before, if you're packaging a release version, you must not include the git revision in your %changelog
 - The description must end with a dot, and more detailed one would be nice, to explain what this specific module does.
 - You must run gtk-update-icon-cache in %postun and %posttrans as your package contains icons. See https://fedoraproject.org/wiki/PackagingDrafts/ScriptletSnippets#GTK.2B_icon_cache
 - Rpmlint complains that one of your Desktop file is not valid:
dde-session-ui.x86_64: E: invalid-desktopfile /usr/share/applications/deepin-toggle-desktop.desktop value "Deepin;" for key "OnlyShowIn" in group "Desktop Entry" contains an unregistered value "Deepin"; values extending the format should start with "X-"

I wasn't able to test it on Rawhide as one package on your copr repo depends on qt 5.7.1. I built it on F26:

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "GPL (v3 or later)", "Unknown or generated". 700 files have
     unknown license. Detailed output of licensecheck in
     /home/bob/packaging/review/dde-session-ui/review-dde-session-
     ui/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/dbus-1,
     /usr/share/dbus-1/services
[x]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/share/dde-session-
     ui/translations(deepin-session-ui), /usr/share/dde-session-ui(deepin-
     session-ui)
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[!]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[!]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in dde-
     session-ui-debuginfo
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: dde-session-ui-4.0.13-1.fc26.x86_64.rpm
          dde-session-ui-debuginfo-4.0.13-1.fc26.x86_64.rpm
          dde-session-ui-4.0.13-1.fc26.src.rpm
dde-session-ui.x86_64: W: spelling-error Summary(en_US) Deepin -> Dee pin, Dee-pin, Deepen
dde-session-ui.x86_64: W: spelling-error %description -l en_US Deepin -> Dee pin, Dee-pin, Deepen
dde-session-ui.x86_64: W: non-conffile-in-etc /etc/xdg/autostart/dde-osd_autostart.desktop
dde-session-ui.x86_64: W: no-manual-page-for-binary dde-lock
dde-session-ui.x86_64: W: no-manual-page-for-binary dde-shutdown
dde-session-ui.x86_64: W: no-manual-page-for-binary dde-switchtogreeter
dde-session-ui.x86_64: W: no-manual-page-for-binary dde-wm-chooser
dde-session-ui.x86_64: W: no-manual-page-for-binary lightdm-deepin-greeter
dde-session-ui.x86_64: E: invalid-desktopfile /usr/share/applications/deepin-toggle-desktop.desktop value "Deepin;" for key "OnlyShowIn" in group "Desktop Entry" contains an unregistered value "Deepin"; values extending the format should start with "X-"
dde-session-ui.x86_64: W: desktopfile-without-binary /usr/share/applications/deepin-toggle-desktop.desktop /usr/libexec/deepin-daemon/desktop-toggle
dde-session-ui.src: W: spelling-error Summary(en_US) Deepin -> Dee pin, Dee-pin, Deepen
dde-session-ui.src: W: spelling-error %description -l en_US Deepin -> Dee pin, Dee-pin, Deepen
3 packages and 0 specfiles checked; 1 errors, 11 warnings.
Comment 3 Robert-André Mauchin 2017-08-06 11:28:11 EDT
Actually after reading the specs, I don't think that rpmlint error is relevant.
Comment 4 Robert-André Mauchin 2017-08-06 11:33:39 EDT
Also, you could use pkgconfig to handle your -devel dependencies.

If you don't know what's the pkgconfig name for a -devel, just search for it with dnf. For example: 

>$dnf repoquery -l deepin-tool-kit-devel | grep ".pc"
>/usr/lib64/pkgconfig/dtkbase.pc
>/usr/lib64/pkgconfig/dtkutil.pc
>/usr/lib64/pkgconfig/dtkwidget.pc
>/usr/lib64/pkgconfig/dtkbase.pc
>/usr/lib64/pkgconfig/dtkutil.pc
>/usr/lib64/pkgconfig/dtkwidget.pc
>/usr/lib64/pkgconfig/dtkbase.pc
>/usr/lib64/pkgconfig/dtkutil.pc
>/usr/lib64/pkgconfig/dtkwidget.pc

so you can add: pkgconfig(dtkbase) as a BR
Comment 5 sensor.wen 2017-08-06 15:03:11 EDT
SPEC:  https://raw.githubusercontent.com/FZUG/repo/0ee362e6a7f81ba7df3ddda0472465154d651e6e/rpms/deepin_project/deepin-session-ui.spec
Diff:  https://github.com/FZUG/repo/commit/0ee362e6a7f81ba7df3ddda0472465154d651e6e

> - The package name should follow upstream convention, dde-session-ui
We want to use same prefix ("deepin-") for Deepin desktop environment packages instead of "dde-". Some projects of deepin use easy to confuse the name, so we made the above changes.

> - You must validate .desktop file with desktop-file-validate in %check. See https://fedoraproject.org/wiki/Packaging:Guidelines#desktop-file-install_usage
> - Rpmlint complains that one of your Desktop file is not valid:
dde-session-ui.x86_64: E: invalid-desktopfile /usr/share/applications/deepin-toggle-desktop.desktop value "Deepin;" for key "OnlyShowIn" in group "Desktop Entry" contains an unregistered value "Deepin"; values extending the format should start with "X-"
The desktop-file-validate command failed due to "Deepin" key not included the desktop-file-utils packages. So i submit new bug for this. (https://bugs.freedesktop.org/show_bug.cgi?id=101878)

> - As I said in other review before, if you're packaging a release version, you must not include the git revision in your %changelog
Fixed

> - The description must end with a dot, and more detailed one would be nice, to explain what this specific module does.
Fixed

> - You must run gtk-update-icon-cache in %postun and %posttrans as your package contains icons. See https://fedoraproject.org/wiki/PackagingDrafts/ScriptletSnippets#GTK.2B_icon_cache
Fixed

> Also, you could use pkgconfig to handle your -devel dependencies.
Fixed, except the deepin-tool-kit, because the upstream decide to split package to dtkcore and dtkwidget, and them doesn‘t compatible.
Comment 6 Robert-André Mauchin 2017-08-09 02:14:35 EDT
It's all good to me, except I can't verify it builds on all architectures on Koji because the dependencies are not yet available in rawhide. Could you build the packages that already have been accepted?


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "GPL (v3 or later)", "Unknown or generated". 700 files have
     unknown license. Detailed output of licensecheck in
     /home/bob/packaging/review/deepin-session-ui/review-deepin-session-
     ui/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/dbus-1,
     /usr/share/dbus-1/services
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: gtk-update-icon-cache is invoked in %postun and %posttrans if package
     contains icons.
     Note: icons in deepin-session-ui
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in deepin-
     session-ui-debuginfo
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: deepin-session-ui-4.0.13-1.fc26.x86_64.rpm
          deepin-session-ui-debuginfo-4.0.13-1.fc26.x86_64.rpm
          deepin-session-ui-4.0.13-1.fc26.src.rpm
deepin-session-ui.x86_64: W: spelling-error %description -l en_US dde -> dd, dded, dude
deepin-session-ui.x86_64: W: spelling-error %description -l en_US lockservice -> lock service, lock-service, serviceable
deepin-session-ui.x86_64: W: spelling-error %description -l en_US switchtogreeter -> switcher
deepin-session-ui.x86_64: W: spelling-error %description -l en_US lowpower -> low power, low-power, Lowery
deepin-session-ui.x86_64: W: spelling-error %description -l en_US osd -> sod, odd, dos
deepin-session-ui.x86_64: W: spelling-error %description -l en_US hotzone -> hot zone, hot-zone, honeypot
deepin-session-ui.x86_64: W: non-conffile-in-etc /etc/xdg/autostart/dde-osd_autostart.desktop
deepin-session-ui.x86_64: W: no-manual-page-for-binary dde-lock
deepin-session-ui.x86_64: W: no-manual-page-for-binary dde-shutdown
deepin-session-ui.x86_64: W: no-manual-page-for-binary dde-switchtogreeter
deepin-session-ui.x86_64: W: no-manual-page-for-binary dde-wm-chooser
deepin-session-ui.x86_64: W: no-manual-page-for-binary lightdm-deepin-greeter
deepin-session-ui.x86_64: E: invalid-desktopfile /usr/share/applications/deepin-toggle-desktop.desktop value "Deepin;" for key "OnlyShowIn" in group "Desktop Entry" contains an unregistered value "Deepin"; values extending the format should start with "X-"
deepin-session-ui.x86_64: W: desktopfile-without-binary /usr/share/applications/deepin-toggle-desktop.desktop /usr/libexec/deepin-daemon/desktop-toggle
deepin-session-ui.src: W: spelling-error %description -l en_US dde -> dd, dded, dude
deepin-session-ui.src: W: spelling-error %description -l en_US lockservice -> lock service, lock-service, serviceable
deepin-session-ui.src: W: spelling-error %description -l en_US lightdm -> light
deepin-session-ui.src: W: spelling-error %description -l en_US switchtogreeter -> switcher
deepin-session-ui.src: W: spelling-error %description -l en_US lowpower -> low power, low-power, Lowery
deepin-session-ui.src: W: spelling-error %description -l en_US osd -> sod, odd, dos
deepin-session-ui.src: W: spelling-error %description -l en_US hotzone -> hot zone, hot-zone, honeypot
3 packages and 0 specfiles checked; 1 errors, 20 warnings.
Comment 7 sensor.wen 2017-08-19 14:58:30 EDT
https://koji.fedoraproject.org/koji/taskinfo?taskID=21332099

Build pass. :)
Comment 8 Robert-André Mauchin 2017-08-19 15:42:23 EDT
Package accpted!

But you need to package deepin-control-center in order to install this package.
Comment 9 Gwyn Ciesla 2017-08-22 09:15:39 EDT
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/deepin-session-ui

Note You need to log in before you can comment on or make changes to this bug.